	
// PanTran.h : Declaration of the CPanTran

#ifndef __PANTRAN_H_
#define __PANTRAN_H_

#include <stdio.h>
#include <float.h>
#include "Transform.h"
#include "PanPlugin.h"
#include "resource.h"       // main symbols
#include "config.h"         // per-Pan generated DXT settings.

/////////////////////////////////////////////////////////////////////////////
// CPanImageImpl
class ATL_NO_VTABLE CPanImageImpl : 
    public CDXBaseNTo1, //orig: public CComObjectRootEx<CComMultiThreadModel>,
    public CComCoClass<CPanImageImpl, &CLSID_NAME>,
    public IDispatchImpl<InterfaceName, &IID_NAME, &LIBID_NAME>,
#if(_ATL_VER < 0x0300)
    public CComPropertySupport<CPanImageImpl>,
#endif
    public IObjectSafetyImpl2<CPanImageImpl>,
    public IPersistStorageImpl<CPanImageImpl>,
    public ISpecifyPropertyPagesImpl<CPanImageImpl>,
    public IPersistPropertyBagImpl<CPanImageImpl>,
    public IOleObjectDXImpl<CPanImageImpl>
{
public:

DECLARE_POLY_AGGREGATABLE(CPanImageImpl)

// orig: DECLARE_REGISTRY_RESOURCEID(IDR_PANTRAN)
DECLARE_REGISTER_DX_TRANSFORM(IDR_PANTRAN, CATID_DXImageTransform)

DECLARE_GET_CONTROLLING_UNKNOWN()

DECLARE_PROTECT_FINAL_CONSTRUCT()
 //DECLARE_IDXEFFECT_METHODS(0)

BEGIN_COM_MAP(CPanImageImpl)
  COM_INTERFACE_ENTRY(IDXEffect)
  COM_INTERFACE_ENTRY(InterfaceName)
  COM_INTERFACE_ENTRY(IDispatch)
  COM_INTERFACE_ENTRY_AGGREGATE(IID_IMarshal, m_pUnkMarshaler.p)
  COM_INTERFACE_ENTRY_IID(IID_IObjectSafety,IObjectSafetyImpl2<CPanImageImpl>)

  COM_INTERFACE_ENTRY(IPersistStorage)
  COM_INTERFACE_ENTRY(ISpecifyPropertyPages)
  COM_INTERFACE_ENTRY(IPersistPropertyBag)

  COM_INTERFACE_ENTRY_DXIMPL(IOleObject)
  COM_INTERFACE_ENTRY_CHAIN(CDXBaseNTo1)
END_COM_MAP()

#if(_ATL_VER >= 0x0300)

    BOOL            m_bRequiresSave;
#endif

  public:
    //=== IDXEffect ======================================================
    DECLARE_IDXEFFECT_METHODS(DXTET_MORPH)

	HRESULT FinalConstruct()
	{
#if(_ATL_VER >= 0x0300)
    m_bRequiresSave = FALSE;
#endif

		return CoCreateFreeThreadedMarshaler(
			GetControllingUnknown(), &m_pUnkMarshaler.p);
	}

	void FinalRelease()
	{
		m_pUnkMarshaler.Release();
	}

	CComPtr<IUnknown> m_pUnkMarshaler;

// IPanTran
public:
	//SIZE m_inputSize;
	//SIZE m_sizeExtent;
    
    CPanImageImpl()
      {
	m_pUnkMarshaler = NULL;
	
	m_ulMaxInputs = NO_IMAGE_INPUTS;
	m_ulNumInRequired = NO_IMAGE_INPUTS;
	m_dwOptionFlags = 0;
	m_dwMiscFlags |= EXTRA_MISC_FLAGS;
	m_ulMaxImageBands = 1;
	
	m_currentWidth = 0;
	m_currentHeight = 0;
	
      }
      
    ~CPanImageImpl() { }
    
    //    void Init();

    // base class (CDXBaseNTo1) overrides:
    //    HRESULT WorkProc( const CDXTWorkInfoNTo1& WI, BOOL* pbContinue );
    //    HRESULT OnSetup( DWORD dwFlags );
    
private:
    //    void Display(int xStart, int yStart, int rWidth, int rHeight, int width, int height, int output, CComPtr<IDXARGBReadWritePtr> pOut, DXPMSAMPLE* pRowBuff, int outY);

    int m_currentWidth;
    int m_currentHeight;
public:

// Bunch of rather ad-hoc macros to make it easier for Pan to
// emit code for a WorkProc.

#define DEFINE_WORKPROC() \
HRESULT \
WorkProc( const CDXTWorkInfoNTo1& WI, BOOL* pbContinue ) \
{ \
    HRESULT hr = S_OK; \
    CComPtr<IDXARGBReadWritePtr>pOut; \
    DXPACKEDRECTDESC rectDesc; \
    RECT r; \
    CDXDBnds bnds; \
    unsigned int rMode;

#define OPEN_READ_SURFACE(x,pBits,pWidth,pHeight,updBits,updWidth,updHeight) \
            CComPtr<IDXARGBReadPtr> pSurface##x; \
            InputSurface((x))->GetBounds(&bnds); \
            pWidth = bnds.Width(); \
            pHeight = bnds.Height(); \
            hr = InputSurface((x))->LockSurface ( NULL /* being more precise seems to upset IE: &WI.DoBnds */ \
                                                , m_ulLockTimeOut \
                                                , DXLOCKF_READ \
                                                , IID_IDXARGBReadPtr \
                                                , (void**)&pSurface##x \
                                                , NULL \
                                                ); \
	     if ( pWidth != m_currentWidth || pHeight != m_currentHeight ) { \
	        CoTaskMemFree((void*)pBits); \
                m_currentHeight = pHeight; \
		m_currentWidth = pWidth; \
		pBits  = (int)CoTaskMemAlloc( (bnds.Width() * bnds.Height()) * sizeof(DXPMSAMPLE) ); \
            } \
	    r.left = bnds.Left(); \
	    r.right = bnds.Right(); \
	    r.top   = bnds.Top(); \
	    r.bottom = bnds.Bottom(); \
\
            rectDesc.pSamples = (DXBASESAMPLE*)pBits; \
            rectDesc.bPremult = TRUE; \
            rectDesc.rect = r; \
            rectDesc.lRowPadding = 0; \
	    /* update the dependent fields */ \
	    updWidth(); updHeight(); updBits(); \
\
            (pSurface##x)->UnpackRect( &rectDesc )

//
//
//
#define CLOSE_READ_SURFACE(x) /*free((void*)x) CoTaskMemFree ( (void*)x ); */

#define INVOKE_TRANSFORM() \
    hr = OutputSurface()->LockSurface ( &WI.OutputBnds \
                                      , m_ulLockTimeOut \
                                      , DXLOCKF_READWRITE \
                                      , IID_IDXARGBReadWritePtr \
                                      , (void**)&pOut \
                                      , NULL \
                                      ); \
    if ( FAILED(hr) ) { \
        return hr; \
    } \
    /* Allocate buffer for output */ \
    ULONG outWidth  = WI.DoBnds.Width(); \
    ULONG outHeight = WI.DoBnds.Height(); \
    \
    /* ToDo: don't allocate/free per invocation, but delay free'ing until \
       you know that the next invocation of the WorkProc is of \
       a different size. */ \
    DXPMSAMPLE* pOutBuff = DXPMSAMPLE_Alloca(outWidth); \
    DXPMSAMPLE* pRowBuff = DXPMSAMPLE_Alloca(outWidth); \
    \
    /* Pan uses round-toward-minus-infinity as its rounding mode */ \
    rMode = _controlfp( _MCW_RC, _RC_DOWN ); \
    \
    width = bnds.Width(); height = bnds.Height(); update_width(); update_height(); \
    /* Invoke generated Display method: */ \
    Display ( WI.DoBnds.Left() \
            , WI.DoBnds.Top() \
	    , outWidth \
            , outHeight \
	    , bnds.Width() \
	    , bnds.Height() \
            , (int)pOutBuff \
	    , pOut \
	    , pRowBuff \
	    , 0 \
            ); \
     /* reset rounding mode */ \
     _controlfp(  _MCW_RC, (rMode &  _MCW_RC))

//
// Note: This macro is used within the code body emitted
//       by Pan, so variable names better match up to the
//       parameters to that method.
// 
//       The second parameter is unused & only there to 
//       avoid running into problems with the Pan backend.
//       (ToDo: fix.)
#define CopyRow(bptr,len) \
   pOut->MoveToRow(outY++); \
   if ( DoOver() ) { \
     pOut->OverArrayAndMove(pRowBuff, (DXPMSAMPLE*)bptr, rWidth); \
   } else { \
     pOut->PackPremultAndMove((DXPMSAMPLE*)bptr, rWidth); \
   }

#define END_WORKPROC() return hr; }

#include "PanTran2.h"
};

#endif //__PANTRAN_H_
