//
// Pan emits its 'display' C function into the file
// 'plugin.c', which we then include here to compile
// &link a standalone filter/plugin viewer.
//

// Excessive measure needed in order to be able to see defn of
// WM_MOUSEWHEEL
#ifndef _WIN32_WINNT
#define _WIN32_WINNT 0x0400
#endif


#include <windows.h>
#include "PanPlugin.h"
#include <atlbase.h>
extern "C" CComModule _Module;
#include <atlcom.h>
#include "PanMainWindow.h"

extern "C" int LoadImportedImg (/*[in]*/  char* lpszFile, int*, int*);

#include "plugin.cpp"

extern "C" {
  CComModule _Module;
};

BEGIN_OBJECT_MAP(ObjectMap)
END_OBJECT_MAP()

#define IDI_SMALL  102

int
APIENTRY
 WinMain
      ( HINSTANCE hInstance
      , HINSTANCE /* hPrevInstance */
      , LPTSTR    /* lpCmdLine     */
      , int       /* nCmdShow      */
      )
{
  USES_CONVERSION;

  HRESULT hRes = CoInitialize(NULL);
  InitCommonControls();
  _Module.Init(ObjectMap, hInstance, NULL);
  
  CComObject<CPanImageImpl> obj;
  CComQIPtr<IPanImage> pImg;
  CComQIPtr<IPanImageUI> pUI;
  CComBSTR szTitle;
  
  obj.QueryInterface(__uuidof(pImg), (void**)&pImg);
  
  pImg->QueryInterface(&pUI);
  
  pUI->GetTitle(&szTitle);
  
  szTitle.Append(TEXT(" - PanViewer"));
  
  CPanMainWindow<IDI_SMALL> mWnd;
  
  RECT r = {0,0,100,100};

  // Create window and display the effect.
  mWnd.Create(NULL,r,OLE2T(szTitle));
  mWnd.OpenEffect(pImg,TEXT("PanEffect"));
  
  // enter msg loop.
  MSG msg;
  int retCode;

  while ((retCode = GetMessage(&msg, 0, 0, 0)) > 0) {
      TranslateMessage(&msg);
      DispatchMessage(&msg);
  }

  // head for the exit.
  CoUninitialize();
  return (retCode < 0 ? -retCode : retCode);
}
